## crash 7.0.8

=== Makefile ===
# Makefile for core analysis suite
#
# Copyright (C) 1999, 2000, 2001, 2002 Mission Critical Linux, Inc.
#       www.missioncriticallinux.com, info@missioncriticallinux.com
#
# Copyright (C) 2002-2013 David Anderson
# Copyright (C) 2002-2013 Red Hat, Inc. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

PROGRAM=crash

#
# Supported targets: X86 ALPHA PPC IA64 PPC64
# TARGET and GDB_CONF_FLAGS will be configured automatically by configure
#
TARGET=
GDB_CONF_FLAGS=

ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
ifeq (${ARCH}, ppc64)
CONF_FLAGS = -m64
endif

#
# GDB, GDB_FILES, GDB_OFILES and GDB_PATCH_FILES will be configured automatically by configure 
#
GDB=gdb-7.6
GDB_FILES=${GDB_7.6_FILES}
GDB_OFILES=
GDB_PATCH_FILES=gdb-7.6.patch gdb-7.6-ppc64le-support.patch

#
# Default installation directory
#
INSTALLDIR=${DESTDIR}/usr/bin

# LDFLAGS will be configured automatically by configure
LDFLAGS=

GENERIC_HFILES=defs.h xen_hyper_defs.h
MCORE_HFILES=va_server.h vas_crash.h
REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h
LKCD_DUMP_HFILES=lkcd_vmdump_v1.h lkcd_vmdump_v2_v3.h lkcd_dump_v5.h \
        lkcd_dump_v7.h lkcd_dump_v8.h
LKCD_OBSOLETE_HFILES=lkcd_fix_mem.h
LKCD_TRACE_HFILES=lkcd_x86_trace.h
IBM_HFILES=ibm_common.h
SADUMP_HFILES=sadump.h
UNWIND_HFILES=unwind.h unwind_i.h rse.h unwind_x86.h unwind_x86_64.h

CFILES=main.c tools.c global_data.c memory.c filesys.c help.c task.c \
	kernel.c test.c gdb_interface.c configure.c net.c dev.c \
	alpha.c x86.c ppc.c ia64.c s390.c s390x.c s390dbf.c ppc64.c x86_64.c \
	arm.c arm64.c \
	extensions.c remote.c va_server.c va_server_v1.c symbols.c cmdline.c \
	lkcd_common.c lkcd_v1.c lkcd_v2_v3.c lkcd_v5.c lkcd_v7.c lkcd_v8.c\
	lkcd_fix_mem.c s390_dump.c lkcd_x86_trace.c \
	netdump.c diskdump.c makedumpfile.c xendump.c unwind.c unwind_decoder.c \
	unwind_x86_32_64.c unwind_arm.c \
	xen_hyper.c xen_hyper_command.c xen_hyper_global_data.c \
	xen_hyper_dump_tables.c kvmdump.c qemu.c qemu-load.c sadump.c ipcs.c \
	ramdump.c

SOURCE_FILES=${CFILES} ${GENERIC_HFILES} ${MCORE_HFILES} \
	${REDHAT_CFILES} ${REDHAT_HFILES} ${UNWIND_HFILES} \
	${LKCD_DUMP_HFILES} ${LKCD_TRACE_HFILES} ${LKCD_OBSOLETE_HFILES}\
	${IBM_HFILES} ${SADUMP_HFILES}

OBJECT_FILES=main.o tools.o global_data.o memory.o filesys.o help.o task.o \
	build_data.o kernel.o test.o gdb_interface.o net.o dev.o \
	alpha.o x86.o ppc.o ia64.o s390.o s390x.o s390dbf.o ppc64.o x86_64.o \
	arm.o arm64.o \
	extensions.o remote.o va_server.o va_server_v1.o symbols.o cmdline.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	lkcd_fix_mem.o s390_dump.o netdump.o diskdump.o makedumpfile.o xendump.o \
	lkcd_x86_trace.o unwind_v1.o unwind_v2.o unwind_v3.o \
	unwind_x86_32_64.o unwind_arm.o \
	xen_hyper.o xen_hyper_command.o xen_hyper_global_data.o \
	xen_hyper_dump_tables.o kvmdump.o qemu.o qemu-load.o sadump.o ipcs.o \
	ramdump.o

MEMORY_DRIVER_FILES=memory_driver/Makefile memory_driver/crash.c memory_driver/README

# These are the current set of crash extensions sources.  They are not built
# by default unless the third command line of the "all:" stanza is uncommented.
# Alternatively, they can be built by entering "make extensions" from this
# directory.

EXTENSIONS=extensions
EXTENSION_SOURCE_FILES=${EXTENSIONS}/Makefile ${EXTENSIONS}/echo.c ${EXTENSIONS}/dminfo.c \
	${EXTENSIONS}/snap.c ${EXTENSIONS}/snap.mk ${EXTENSIONS}/trace.c \
	${EXTENSIONS}/eppic.c ${EXTENSIONS}/eppic.mk

DAEMON_OBJECT_FILES=remote_daemon.o va_server.o va_server_v1.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	s390_dump.o netdump_daemon.o

GDB_5.0_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/gnu-regex.c \
	  ${GDB}/gdb/ppc-linux-nat.c
GDB_5.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o \
          ${GDB}/gdb/ppc-linux-nat.o

GDB_5.1_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c  ${GDB}/gdb/gnu-regex.c
GDB_5.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o

GDB_5.2.1_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c
GDB_5.2.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o 

GDB_5.3post-0.20021129.36rh_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/frame.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c
GDB_5.3post-0.20021129.36rh_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/frame.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o ${GDB}/gdb/ui-file.o \
          ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o

GDB_6.0_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c \
	  ${GDB}/gdb/ppc-linux-tdep.c ${GDB}/sim/ppc/ppc-instructions \
	  ${GDB}/bfd/simple.c ${GDB}/include/obstack.h
GDB_6.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o \
	  ${GDB}/gdb/ppc-linux-tdep.o ${GDB}/bfd/simple.o

GDB_6.1_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c \
          ${GDB}/include/obstack.h ${GDB}/gdb/ppc-linux-tdep.c
GDB_6.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o \
          ${GDB}/gdb/ppc-linux-tdep.o

GDB_7.0_FILES=
GDB_7.0_OFILES=${GDB}/gdb/symtab.o

GDB_7.3.1_FILES=
GDB_7.3.1_OFILES=${GDB}/gdb/symtab.o

GDB_7.6_FILES=
GDB_7.6_OFILES=${GDB}/gdb/symtab.o

# 
# GDB_FLAGS is passed up from the gdb Makefile.
#
GDB_FLAGS=

#
# WARNING_OPTIONS and WARNING_ERROR are both applied on a per-file basis. 
# WARNING_ERROR is NOT used on files including "dirty" gdb headers so that 
# successful compilations can be achieved with acceptable warnings; its 
# usefulness is also dependent upon the processor's compiler -- your mileage
# may vary.
#
#WARNING_OPTIONS=-Wall -O2 -Wstrict-prototypes -Wmissing-prototypes -fstack-protector -Wformat-security
#WARNING_ERROR=-Werror

# TARGET_CFLAGS will be configured automatically by configure
TARGET_CFLAGS=

CRASH_CFLAGS=-g -D${TARGET} ${TARGET_CFLAGS} ${GDB_FLAGS} ${CFLAGS}

GPL_FILES=COPYING3
TAR_FILES=${SOURCE_FILES} Makefile ${GPL_FILES} README .rh_rpm_package crash.8 \
	${EXTENSION_SOURCE_FILES} ${MEMORY_DRIVER_FILES}
CSCOPE_FILES=${SOURCE_FILES}

READLINE_DIRECTORY=./${GDB}/readline
BFD_DIRECTORY=./${GDB}/bfd
GDB_INCLUDE_DIRECTORY=./${GDB}/include

REDHATFLAGS=-DREDHAT

# target could be set on command line when invoking make. Like: make target=ARM
# otherwise target will be the same as the host
ifneq ($(target),)
CONF_TARGET_FLAG="-t$(target)"
endif

# To build the extensions library by default, uncomment the third command
# line below.  Otherwise they can be built by entering "make extensions".

all: make_configure
	@./configure ${CONF_TARGET_FLAG} -p "RPMPKG=${RPMPKG}" -b
	@make --no-print-directory gdb_merge
#	@make --no-print-directory extensions

gdb_merge: force
	@if [ ! -f ${GDB}/README ]; then \
	  make --no-print-directory gdb_unzip; fi
	@echo "${LDFLAGS} -lz -ldl -rdynamic" > ${GDB}/gdb/mergelibs
	@echo "../../${PROGRAM} ../../${PROGRAM}lib.a" > ${GDB}/gdb/mergeobj
	@rm -f ${PROGRAM}
	@if [ ! -f ${GDB}/config.status ]; then \
	  (cd ${GDB}; ./configure ${GDB_CONF_FLAGS} --with-separate-debug-dir=/usr/lib/debug \
	    --with-bugurl="" --with-expat=no --with-python=no; \
	  make --no-print-directory CRASH_TARGET=${TARGET}; echo ${TARGET} > crash.target) \
	else make --no-print-directory rebuild; fi
	@if [ ! -f ${PROGRAM} ]; then \
	  echo; echo "${PROGRAM} build failed"; \
	  echo; exit 1; fi

rebuild:
	@if [ ! -f ${GDB}/${GDB}.patch ]; then \
	  touch ${GDB}/${GDB}.patch; fi
	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
	  (patch -N -p0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
	  make --no-print-directory CRASH_TARGET=${TARGET}) \
	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi

gdb_unzip:
	@rm -f gdb.files
	@for FILE in ${GDB_FILES} dummy; do\
	  echo $$FILE >> gdb.files; done
	@if [ ! -f ${GDB}.tar.gz ] && [ ! -f /usr/bin/wget ]; then \
	  echo /usr/bin/wget is required to download ${GDB}.tar.gz; echo; exit 1; fi
	@if [ ! -f ${GDB}.tar.gz ] && [ -f /usr/bin/wget ]; then \
	  wget http://ftp.gnu.org/gnu/gdb/${GDB}.tar.gz; fi
	@tar --exclude-from gdb.files -xvzmf ${GDB}.tar.gz
	@make --no-print-directory gdb_patch

gdb_patch:
	if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ]; then \
		patch -p0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; fi
	if [ "${ARCH}" = "ppc64le" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
	fi

library: make_build_data ${OBJECT_FILES}
	ar -rs ${PROGRAM}lib.a ${OBJECT_FILES}

gdb: force
	rm -f ${GDB_OFILES}
	@make --no-print-directory all

force:
	

make_configure: force
	@rm -f configure
	@${CC} ${CONF_FLAGS} -o configure configure.c ${WARNING_ERROR} ${WARNING_OPTIONS}

clean: make_configure
	@./configure ${CONF_TARGET_FLAG} -q -b
	@make --no-print-directory do_clean

do_clean:
	rm -f ${OBJECT_FILES} ${DAEMON_OBJECT_FILES} ${PROGRAM} ${PROGRAM}lib.a ${GDB_OFILES}
	@(cd extensions; make --no-print-directory -i clean)
	@(cd memory_driver; make --no-print-directory -i clean)

make_build_data: force
	${CC} -c ${CRASH_CFLAGS} build_data.c ${WARNING_OPTIONS} ${WARNING_ERROR}

install:
	/usr/bin/install ${PROGRAM} ${INSTALLDIR}
#	/usr/bin/install ${PROGRAM}d ${INSTALLDIR}

unconfig: make_configure
	@./configure -u

warn: make_configure
	@./configure ${CONF_TARGET_FLAG} -w -b
	@make --no-print-directory gdb_merge

Warn: make_configure
	@./configure ${CONF_TARGET_FLAG} -W -b
	@make --no-print-directory gdb_merge

nowarn: make_configure

## crash 7.1.1

=== Makefile ===
--- 
+++ 
@@ -57,11 +57,12 @@
 IBM_HFILES=ibm_common.h
 SADUMP_HFILES=sadump.h
 UNWIND_HFILES=unwind.h unwind_i.h rse.h unwind_x86.h unwind_x86_64.h
+VMWARE_HFILES=vmware_vmss.h
 
 CFILES=main.c tools.c global_data.c memory.c filesys.c help.c task.c \
 	kernel.c test.c gdb_interface.c configure.c net.c dev.c \
 	alpha.c x86.c ppc.c ia64.c s390.c s390x.c s390dbf.c ppc64.c x86_64.c \
-	arm.c arm64.c \
+	arm.c arm64.c mips.c \
 	extensions.c remote.c va_server.c va_server_v1.c symbols.c cmdline.c \
 	lkcd_common.c lkcd_v1.c lkcd_v2_v3.c lkcd_v5.c lkcd_v7.c lkcd_v8.c\
 	lkcd_fix_mem.c s390_dump.c lkcd_x86_trace.c \
@@ -69,17 +70,17 @@
 	unwind_x86_32_64.c unwind_arm.c \
 	xen_hyper.c xen_hyper_command.c xen_hyper_global_data.c \
 	xen_hyper_dump_tables.c kvmdump.c qemu.c qemu-load.c sadump.c ipcs.c \
-	ramdump.c
+	ramdump.c vmware_vmss.c
 
 SOURCE_FILES=${CFILES} ${GENERIC_HFILES} ${MCORE_HFILES} \
 	${REDHAT_CFILES} ${REDHAT_HFILES} ${UNWIND_HFILES} \
 	${LKCD_DUMP_HFILES} ${LKCD_TRACE_HFILES} ${LKCD_OBSOLETE_HFILES}\
-	${IBM_HFILES} ${SADUMP_HFILES}
+	${IBM_HFILES} ${SADUMP_HFILES} ${VMWARE_HFILES}
 
 OBJECT_FILES=main.o tools.o global_data.o memory.o filesys.o help.o task.o \
 	build_data.o kernel.o test.o gdb_interface.o net.o dev.o \
 	alpha.o x86.o ppc.o ia64.o s390.o s390x.o s390dbf.o ppc64.o x86_64.o \
-	arm.o arm64.o \
+	arm.o arm64.o mips.o \
 	extensions.o remote.o va_server.o va_server_v1.o symbols.o cmdline.o \
 	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
 	lkcd_fix_mem.o s390_dump.o netdump.o diskdump.o makedumpfile.o xendump.o \
@@ -87,7 +88,7 @@
 	unwind_x86_32_64.o unwind_arm.o \
 	xen_hyper.o xen_hyper_command.o xen_hyper_global_data.o \
 	xen_hyper_dump_tables.o kvmdump.o qemu.o qemu-load.o sadump.o ipcs.o \
-	ramdump.o
+	ramdump.o vmware_vmss.o
 
 MEMORY_DRIVER_FILES=memory_driver/Makefile memory_driver/crash.c memory_driver/README
 
@@ -242,7 +243,7 @@
 	  touch ${GDB}/${GDB}.patch; fi
 	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
 	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
-	  (patch -N -p0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
+	  (patch -N -p0 -r- < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
 	  make --no-print-directory CRASH_TARGET=${TARGET}) \
 	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi
 
@@ -263,6 +264,9 @@
 	if [ "${ARCH}" = "ppc64le" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
 		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
 	fi
+	if [ "${ARCH}" = "x86_64" ] && [ "${TARGET}" = "PPC64" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
+		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
+	fi
 
 library: make_build_data ${OBJECT_FILES}
 	ar -rs ${PROGRAM}lib.a ${OBJECT_FILES}
@@ -294,15 +298,3 @@
 	/usr/bin/install ${PROGRAM} ${INSTALLDIR}
 #	/usr/bin/install ${PROGRAM}d ${INSTALLDIR}
 
-unconfig: make_configure
-	@./configure -u
-
-warn: make_configure
-	@./configure ${CONF_TARGET_FLAG} -w -b
-	@make --no-print-directory gdb_merge
-
-Warn: make_configure
-	@./configure ${CONF_TARGET_FLAG} -W -b
-	@make --no-print-directory gdb_merge
-
-nowarn: make_configure

## crash 7.1.4

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 # LDFLAGS will be configured automatically by configure
 LDFLAGS=
 
-GENERIC_HFILES=defs.h xen_hyper_defs.h
+GENERIC_HFILES=defs.h xen_hyper_defs.h xen_dom0.h
 MCORE_HFILES=va_server.h vas_crash.h
 REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h
 LKCD_DUMP_HFILES=lkcd_vmdump_v1.h lkcd_vmdump_v2_v3.h lkcd_dump_v5.h \
@@ -70,7 +70,8 @@
 	unwind_x86_32_64.c unwind_arm.c \
 	xen_hyper.c xen_hyper_command.c xen_hyper_global_data.c \
 	xen_hyper_dump_tables.c kvmdump.c qemu.c qemu-load.c sadump.c ipcs.c \
-	ramdump.c vmware_vmss.c
+	ramdump.c vmware_vmss.c \
+	xen_dom0.c
 
 SOURCE_FILES=${CFILES} ${GENERIC_HFILES} ${MCORE_HFILES} \
 	${REDHAT_CFILES} ${REDHAT_HFILES} ${UNWIND_HFILES} \
@@ -88,7 +89,8 @@
 	unwind_x86_32_64.o unwind_arm.o \
 	xen_hyper.o xen_hyper_command.o xen_hyper_global_data.o \
 	xen_hyper_dump_tables.o kvmdump.o qemu.o qemu-load.o sadump.o ipcs.o \
-	ramdump.o vmware_vmss.o
+	ramdump.o vmware_vmss.o \
+	xen_dom0.o
 
 MEMORY_DRIVER_FILES=memory_driver/Makefile memory_driver/crash.c memory_driver/README
 
@@ -296,5 +298,3 @@
 
 install:
 	/usr/bin/install ${PROGRAM} ${INSTALLDIR}
-#	/usr/bin/install ${PROGRAM}d ${INSTALLDIR}
-

## crash 7.1.7

=== Makefile ===
--- 
+++ 
@@ -3,8 +3,8 @@
 # Copyright (C) 1999, 2000, 2001, 2002 Mission Critical Linux, Inc.
 #       www.missioncriticallinux.com, info@missioncriticallinux.com
 #
-# Copyright (C) 2002-2013 David Anderson
-# Copyright (C) 2002-2013 Red Hat, Inc. All rights reserved.
+# Copyright (C) 2002-2016 David Anderson
+# Copyright (C) 2002-2016 Red Hat, Inc. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,7 @@
 PROGRAM=crash
 
 #
-# Supported targets: X86 ALPHA PPC IA64 PPC64
+# Supported targets: X86 ALPHA PPC IA64 PPC64 SPARC64
 # TARGET and GDB_CONF_FLAGS will be configured automatically by configure
 #
 TARGET=
@@ -62,7 +62,7 @@
 CFILES=main.c tools.c global_data.c memory.c filesys.c help.c task.c \
 	kernel.c test.c gdb_interface.c configure.c net.c dev.c \
 	alpha.c x86.c ppc.c ia64.c s390.c s390x.c s390dbf.c ppc64.c x86_64.c \
-	arm.c arm64.c mips.c \
+	arm.c arm64.c mips.c sparc64.c \
 	extensions.c remote.c va_server.c va_server_v1.c symbols.c cmdline.c \
 	lkcd_common.c lkcd_v1.c lkcd_v2_v3.c lkcd_v5.c lkcd_v7.c lkcd_v8.c\
 	lkcd_fix_mem.c s390_dump.c lkcd_x86_trace.c \
@@ -81,7 +81,7 @@
 OBJECT_FILES=main.o tools.o global_data.o memory.o filesys.o help.o task.o \
 	build_data.o kernel.o test.o gdb_interface.o net.o dev.o \
 	alpha.o x86.o ppc.o ia64.o s390.o s390x.o s390dbf.o ppc64.o x86_64.o \
-	arm.o arm64.o mips.o \
+	arm.o arm64.o mips.o sparc64.o \
 	extensions.o remote.o va_server.o va_server_v1.o symbols.o cmdline.o \
 	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
 	lkcd_fix_mem.o s390_dump.o netdump.o diskdump.o makedumpfile.o xendump.o \
@@ -233,7 +233,7 @@
 	@rm -f ${PROGRAM}
 	@if [ ! -f ${GDB}/config.status ]; then \
 	  (cd ${GDB}; ./configure ${GDB_CONF_FLAGS} --with-separate-debug-dir=/usr/lib/debug \
-	    --with-bugurl="" --with-expat=no --with-python=no; \
+	    --with-bugurl="" --with-expat=no --with-python=no --disable-sim; \
 	  make --no-print-directory CRASH_TARGET=${TARGET}; echo ${TARGET} > crash.target) \
 	else make --no-print-directory rebuild; fi
 	@if [ ! -f ${PROGRAM} ]; then \
@@ -245,7 +245,7 @@
 	  touch ${GDB}/${GDB}.patch; fi
 	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
 	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
-	  (patch -N -p0 -r- < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
+	  (patch -N -p0 -r- --fuzz=0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
 	  make --no-print-directory CRASH_TARGET=${TARGET}) \
 	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi
 
@@ -297,4 +297,3 @@
 	${CC} -c ${CRASH_CFLAGS} build_data.c ${WARNING_OPTIONS} ${WARNING_ERROR}
 
 install:
-	/usr/bin/install ${PROGRAM} ${INSTALLDIR}

## crash 7.1.8

=== debian/changelog ===
crash (7.1.8-1ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable (LP: #1672361).  Remaining changes:
    - Build for armhf, ppc64el.
    - Minor fixes for live autopkgtest.

 -- Stefan Bader <stefan.bader@canonical.com>  Fri, 17 Mar 2017 14:03:05 +0100

crash (7.1.8-1) unstable; urgency=medium

  * New upstream 7.1.8  (Closes: #851882)

  * Accepted patch from Chris J Arges <chris.j.arges@canonical.com> to fix
    autopkgtest failures (Closes: #788239)

  * Builds with gcc 7 (Closes: #853357)

  * Fix for Linux 4.6 commit b03a017bebc403d40aa53a092e79b3020786537d, which
    introduced the new slab management type OBJFREELIST_SLAB.  In this mode,
    the freelist can be an object, and if the slab is full, there is no
    freelist.  On the next free, an object is recycled to be used as the
    freelist but not cleaned-up.  This patch will go through only known freed
    objects, and will prevent "kmem -S" errors that indicate "invalid/corrupt
    freelist entry" on kernels configured with CONFIG_SLAB.

  * Fix for the initialization-time loading of kernel module symbols if the
    kernel crashed while running a module's initcall.  Without the patch, the
    crash session fails during initialation with a message similar to "crash:
    store_module_symbols_v2: total: 7 mcnt: 8".

  * Fix for a segmentation violation during session inialization when running
    against a 32-bit MIPS ELF kdump or compressed kdump if a per-cpu
    NT_PRSTATUS note cannot be gathered from the dumpfile header.  Without the
    the patch, a segmentation violation occurs after the message "WARNING:
    cannot find NT_PRSTATUS note for cpu: <number>" is displayed.

  * The 32-bit MIPS PGD_ORDER() macro expects __PGD_ORDER to be signed, which
    it isn't now since the internal machdep->pagesize is unsigned.  Without
    this patch, module loading fails during initialization on a kernel that
    has a page size of 16KB, with messages that indicate "please wait...
    (gathering module symbol data)" followed by "crash: invalid size request:
    0  type: pgd page".

  * For ARM64 dumpfiles with VMCOREINFO, verify the new "VA_BITS" number
    against the calculated number.

  * Fix for the ARM64 "bt" command in Linux 4.10 and later kernels that are
    configured with CONFIG_THREAD_INFO_IN_TASK.  Without the patch, the "bt"
    command will fail for active tasks in dumpfiles that were generated by the
    kdump facility.

  * Fix for Linux 4.10 commit 7fd8329ba502ef76dd91db561c7aed696b2c7720
    "taint/module: Clean up global and module taint flags handling".  Without
    the patch, when running against Linux 4.10-rc1 and later kernels, the
    crash utility fails during session initialization with the message "crash:
    invalid structure size: tnt".

  * Fix for support of /proc/kcore as the live memory source in Linux 4.8 and
    later x86_64 kernels configured with CONFIG_RANDOMIZE_BASE, which
    randomizes the unity-mapping PAGE_OFFSET value.  Without the patch, the
    crash session fails during session initialization with the error message
    "crash: seek error: kernel virtual address: <address> type:
    page_offset_base".

  * Update to the module taint flags handling patch above to account for the
    change in size of the module.taints flag from an int to a long, while
    allowing for a kernel backport that keeps it as an int.

  * Prepare for the kernel's "taint_flag.true" and "taint_flag.false" member
    names to be changed to "c_true" and "c_false", which fixes build problems
    when an out-of-tree module defines "true" or "false".

  * Prevent the livepatch taint flag check during the system banner display
    from generating a fatal session-killing error if relevant kernel symbol
    names or data structures change in the future (again).

  * Fix for the PPC64 "bt" command for non-panicking active tasks in
    FADUMP-generated dumpfiles (Firmware Assisted Dump facility).  Without the
    patch, backtraces of those tasks may be of the form "#0 [c0000000700b3a90]
    (null) at c0000000700b3b50  (unreliable)".  This patch uses and displays
    the ptregs register set saved in the dumpfile header for the non-panicking
    active tasks.

  * Fix for a possible segmentation violation when analyzing Linux 4.6 and
    earlier x86_64 kernels configured with CONFIG_RANDOMIZE_BASE.  A
    segmentation violation may occur during session initialization, just after
    the patching of the gdb minimal_symbol values message, depending upon the
    value of KERNEL_IMAGE_SIZE, which was variable in the earlier KASLR
    kernels.  This patch sets the KERNEL_IMAGE_SIZE default value to 1GB for
    those earlier kernels, and also adds a new "--machdep
    kernel_image_size=<value>" option that can be used to override the default
    KERNEL_IMAGE_SIZE value if necessary.

  * Fix the bracketing of the x86_64 FILL_PML4() macro.

  * Fix for the "tree -t radix", "irq", and "files -p" command options in
    Linux 4.6 and later kernels due to upstream changes in the radix tree
    facility.  Without the patch, the commands will fail with the message
    "radix trees do not exist or have changed their format".

  * Fix for the "trace.c" extension module.  The kernel buffer referenced by
    "max_tr_ring_buffer" is not available in all configurations of the kernel
    so the unitialized max_tr_ring_buffer variable should not be used.  A
    similar check existed previously before the recent rework of the trace
    extension module to support multiple buffers.

  * Clarification in the display of CONFIG_SLUB object addresses that are
    displayed by the "kmem" command when SLAB_RED_ZONE has been enabled.  By
    default, CONFIG_SLUB object addresses that are displayed by the "kmem"
    command will  point to the SLAB_RED_ZONE padding inserted at the beginning
    of the object.  As an alternative, a new "redzone" environment variable
    has been addedd that can be toggled on or off.  If "set redzone off" is


=== debian/control ===
Source: crash
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
Uploaders:
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev
Standards-Version: 3.9.8.0
XS-Testsuite: autopkgtest

Package: crash
Architecture: i386 ia64 alpha powerpc ppc64el amd64 arm64 armel armhf s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
Suggests: kexec-tools, makedumpfile
Description: kernel debugging utility, allowing gdb like syntax
 The core analysis suite is a self-contained tool that can be used to
 investigate either live systems, or multiple different core dump formats
 including kdump, LKCD, netdump and diskdump.
 .
 o  The tool is loosely based on the SVR4 crash command, but has been
    completely integrated with gdb in order to be able to display
    formatted kernel data structures, disassemble source code, etc.
 .
 o  The current set of available commands consist of common kernel core
    analysis tools such as a context-specific stack traces, source code
    disassembly, kernel variable displays, memory display, dumps of
    linked-lists, etc.  In addition, any gdb command may be entered,
    which in turn will be passed onto the gdb module for execution.
 .
 o  There are several commands that delve deeper into specific kernel
    subsystems, which also serve as templates for kernel developers
    to create new commands for analysis of a specific area of interest.
    Adding a new command is a simple affair, and a quick recompile
    adds it to the command menu.
 .
 o  The intent is to make the tool independent of Linux version dependencies,
    building in recognition of major kernel code changes so as to adapt to
    new kernel versions, while maintaining backwards compatibility.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export EXTDIR=/usr/lib/crash/extensions
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --with quilt

override_dh_auto_build:
	dh_auto_build 
	$(MAKE) extensions

override_dh_auto_clean:
	cp $(CURDIR)/Makefile $(CURDIR)/debian/Makefile.ori
	dh_auto_clean

override_dh_clean:
	dh_clean
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	rm -Rf $(CURDIR)/configure
	rm -Rf $(CURDIR)/gdb-7.6
	rm -Rf $(CURDIR)/gdb.files
	rm -Rf $(CURDIR)/build_data.c
	rm -Rf $(CURDIR)/extensions/*.so

override_dh_auto_install:
	dh_auto_install
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	mkdir -p $(CURDIR)/debian/crash$(EXTDIR)
	cp -p extensions/*.so $(CURDIR)/debian/crash$(EXTDIR)

override_dh_auto_test:
	# Crash does not provide a testsuite

=== debian/tests/control ===
Tests: live
Restrictions: needs-root
Depends: @, lsb-release, sudo

## crash 7.1.9

=== debian/changelog ===
crash (7.1.9-1) unstable; urgency=medium

  * Patch from Balint Reczey <rbalint@ubuntu.com>: Build crash on all Linux
    architectures (Closes: #763856, #757450)

  * Patch from Balint Reczey <rbalint@ubuntu.com>: Continuous integration
    tests can fail due to missing packages for the running kernel and missing
    *-updates packages (Closes: #869367)

  * Fixes to address three gcc-7.0.1 compiler warnings that are generated when
    building with "make warn".  The warning types are "[-Wnonnull]" in
    filesys.c, and "[-Wformat-overflow=]" in kernel.c and cmdline.c.

  * Fix for the PPC64 "mach -o" option to update the OPAL console buffer size
    from 256K to 1MB, based upon the latest skiboot firmware source.

  * Fix for the "mod -[sS]" option to prevent the erroneous reassignment of
    one or more symbol values of a kernel module.  Without the patch, when
    loading a kernel module, a message may indicate "mod: <module>: last
    symbol: <symbol> is not _MODULE_END_<module>?" may be displayed, and one
    or more symbols may be reassigned an incorrect symbol value.  If none of
    the erroneous symbol value reassignments are beyond the end of the
    module's address space, then there will be no message.

  * Linux 4.10 commit 401721ecd1dcb0a428aa5d6832ee05ffbdbffbbe finally exports
    the x86_64 "phys_base" value in the VMCOREINFO note, so utilize it
    whenever it exists.

  * Implemented a new "log -a" option that dumps the audit logs remaining in
    kernel audit buffers that have not been copied out to the user-space audit
    daemon.

  * Fix for the "kmem <address>" option and the "search" command in x86_64
    kernels that contain, or have backports of, kernel commit
    7c1da8d0d046174a4188b5729d7579abf3d29427, titled "crypto: sha - SHA1
    transform x86_64 AVX2", which introduced an "_end" text symbol.  Without
    the patch, if a base kernel symbol address that is larger than the "_end"
    text symbol is passed to "kmem <address>", its symbol/filename information
    will not be displayed.  Also, when the "search" command scans the
    __START_KERNEL_map region that contains kernel text and static data, the
    search will be truncated to stop at the "_end" text symbol address.

  * Enhancement for the determination of the ARM64 "kimage_voffset" value in
    Linux 4.6 and later kernels if an ELF format dumpfile does not contain its
    value in a VMCOREINFO note, or when running against live systems using
    /dev/mem, /proc/kcore, or an older version of /dev/crash.

  * Optimization of the "kmem -f <address>" and "kmem <r;address>" options to
    significantly reduce the amount of time to complete the buddy allocator
    free-list scan for the target address.  On very large memory systems, the
    patch may reduce the time spent by several orders of magnitude.

  * Fix for a compilation error if glibc-2.25 or later has been installed on
    the host build machine.  Without the patch, the build fails with the error
    message "amd64-linux-nat.c:496:1: error: conflicting types for
    'ps_get_thread_area'".

  * Fix for the "list -[hH]" options if a list_head.next pointer is
    encountered that contains an invalid NULL pointer.  Without the patch, the
    "list -[hH]" options would complete/continue as if the NULL were a
    legitimate end-of-list indicator, and no error would be reported.

  * Provide basic Huge Page usage as part of "kmem -i" output, showing the
    total amount of memory allocated for huge pages, and the amount of the
    total that is free.

  * Fix for the determination of the x86_64 "phys_base" value when it is not
    passed in the VMCOREINFO data of ELF vmcores.  Without the patch, it is
    possible that the base address of the vmalloc region is unknown and
    initialized to an incorrect default address during the very early stages
    of initialization, which causes the parsing of the PT_LOAD segments for
    the START_KERNEL_map region to fail.

  * Fix for the "dis" command to detect duplicate symbols in the case of a
    "symbol+offset" argument where the duplicates are contiguous in the symbol
    list.  In addition, reject "symbol+offset" arguments if the resultant
    address goes beyond the end of the function.

  * Fix for the "set scope" option if the kernel was configured with
    CONFIG_RANDOMIZE_BASE.  Without the patch, the command fails with the
    message "set: gdb cannot find text block for address: <symbol>".  This
    also affects extension modules that call gdb_set_crash_scope() when
    running with KASLR kernels.

  * Fix for the extensions/trace.c extension module to account for Linux 4.7
    kernel commit 9b94a8fba501f38368aef6ac1b30e7335252a220, which changed the
    ring_buffer_per_cpu.nr_pages member from an int to a long.  Without the
    patch, the trace.so extension module fails to load on big-endian machines,
    indicating "extend: Num of pages is less than 0".

  * Fix for the extensions/trace.c extension module when running on the ppc64
    architecture.  Without the patch, the trace.so extension module fails to
    load, indicating "extend: invalid text address: ring_buffer_read".  On the
    ppc64 architecture, the text symbol is ".ring_buffer_read".

  * Fix for the ARM64 "bt" command.  Without the patch, the backtrace of a
    non-panicking active task generates a segmentation violation when
    analyzing Android 4.4-based dumpfiles.

 -- Troy Heber <troyh@debian.org>  Wed, 26 Jul 2017 12:37:08 -0600

crash (7.1.8-2) unstable; urgency=medium

  * Enable lzo and snappy compression (Closes: #860319)

 -- Troy Heber <troyh@debian.org>  Mon, 17 Apr 2017 19:25:16 -0600

crash (5.1.1-1) unstable; urgency=low

  * New upstream version 5.1.1 (see
    http://people.redhat.com/anderson/crash.changelog)
  * Fix for the potential to miss tasks when walking the pid_hash table in
    2.6.24 and later kernels.
  * Enhancement for the ARM architecture's "bt" command  to print out the user


=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: crash
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
+Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
 Standards-Version: 3.9.8.0
 XS-Testsuite: autopkgtest
 
 Package: crash
-Architecture: i386 ia64 alpha powerpc ppc64el amd64 arm64 armel armhf s390x
+Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
 Suggests: kexec-tools, makedumpfile
 Description: kernel debugging utility, allowing gdb like syntax

## crash 7.2.1

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 GDB=gdb-7.6
 GDB_FILES=${GDB_7.6_FILES}
 GDB_OFILES=
-GDB_PATCH_FILES=gdb-7.6.patch gdb-7.6-ppc64le-support.patch
+GDB_PATCH_FILES=gdb-7.6.patch gdb-7.6-ppc64le-support.patch gdb-7.6-proc_service.h.patch
 
 #
 # Default installation directory
@@ -269,6 +269,12 @@
 	if [ "${ARCH}" = "x86_64" ] && [ "${TARGET}" = "PPC64" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
 		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
 	fi
+	if [ -f /usr/include/proc_service.h ]; then \
+		grep 'extern ps_err_e ps_get_thread_area (struct' /usr/include/proc_service.h; \
+		if [ $$? -eq 0 ]; then \
+			patch -p0 < ${GDB}-proc_service.h.patch; \
+		fi; \
+	fi
 
 library: make_build_data ${OBJECT_FILES}
 	ar -rs ${PROGRAM}lib.a ${OBJECT_FILES}
@@ -289,11 +295,3 @@
 	@make --no-print-directory do_clean
 
 do_clean:
-	rm -f ${OBJECT_FILES} ${DAEMON_OBJECT_FILES} ${PROGRAM} ${PROGRAM}lib.a ${GDB_OFILES}
-	@(cd extensions; make --no-print-directory -i clean)
-	@(cd memory_driver; make --no-print-directory -i clean)
-
-make_build_data: force
-	${CC} -c ${CRASH_CFLAGS} build_data.c ${WARNING_OPTIONS} ${WARNING_ERROR}
-
-install:

=== debian/changelog ===
crash (7.2.1-1) unstable; urgency=medium

  * New upstream (closes: #890394)

  * Fix for the "runq" command on Linux 4.14 and later kernels that contain
    commit cd9e61ed1eebbcd5dfad59475d41ec58d9b64b6a, titled "rbtree: cache
    leftmost node internally".  Without the patch, the command fails with the
    error message "runq: invalid structure member offset: cfs_rq_rb_leftmost".

  * Fix to prevent a useless message during session inialization.  Without the
    patch, if the highest possible node bit in the node_states[N_ONLINE]
    multi-word bitmask is set, then a message such as "crash:
    next_online_node: 256 is too large!" will be displayed.

  * Additional fixes for the ARM64 "bt" command for Linux 4.14 kernels.  The
    patch corrects the contents of in-kernel exception frame register dumps,
    and properly transitions the backtrace from the IRQ stack to the process
    stack.

  * Implemented a new "search -T" option, which is identical to the "search
    -t" option, except that the search is restricted to the kernel stacks of
    active tasks.

  * Removal of the ARM64 "bt -o" option for Linux 4.14 and later kernels,
    along with several cleanups/readability improvements.

  * Fix for support of KASLR enabled kernels captured by the SADUMP dumpfile
    facility. SADUMP dumpfile headers do not contain phys_base or VMCOREINFO
    notes, so without this patch, the crash session fails during
    initialization with the message "crash: seek error: kernel virtual
    address: <address>  type: "page_offset_base".  This patch calculates the
    phys_base value and the KASLR offset using the IDTR and CR3 registers from
    the dumpfile header.

  * Implemented a new "ps -y policy" option to filter the task display by
    scheduling policy.  Applicable to both standalone ps invocation as well as
    via foreach.

  * Fix for the "kmem -[sS]" options on Linux 4.14 and later kernels that
    contain commit 2482ddec670fb83717d129012bc558777cb159f7, titled "mm: add
    SLUB free list pointer obfuscation".  Without the patch, there will
    numerous error messages of the type "kmem: <cache name> slab: <address>
    invalid freepointer: <obfuscated address>" if the kernel is configured
    with CONFIG_SLAB_FREELIST_HARDENED.

  * Fix for the validation of the bits located in the least significant bits of
    mem_section.section_mem_map pointers.  Without the patch, the validation
    functions always returned valid, due to a coding error found by clang.
    However, it was never really a problem because it is extremely unlikely
    that an existing mem_section would ever be invalid.

  * Fix for the x86_64 kernel virtual address to physical address translation
    mechanism.  Without the patch, when verifying that the PAGE_PRESENT bit is
    set in the top-level page table, it would always test positively, and the
    translation would continue parsing the remainder of the page tables.  This
    would virtually never be a problem in practice because if the top-level
    page table entry existed, its PAGE_PRESENT bit would be set.

  * Removed a check for a negative block_size value which is always a
    non-negative unsigned value in the SADUMP header parsing function.

  * Removed a check for an impossible negative value when calculating the
    beginning address when applying the context value specified by the "search
    -x <count>" option.

  * Implemented a new "timer -C <cpu-specifier>" option that restricts the
    timer or hrtimer output to the timer queue data associated with one or
    more cpus.  For multiple cpus, the cpu-specifier uses the standard comma
    or dash separated list format.

  * Fix for a "ps -l" regression introduced by the new "ps -y" option
    introduced above.  Without the patch, the -l option generates a
    segmentation violation if not accompanied by a -C cpu specifier option.

  * Fix for the "kmem -i" and "kmem -V" options in Linux 4.8 and later kernels
    containing commit 75ef7184053989118d3814c558a9af62e7376a58, titled "mm,
    vmstat: add infrastructure for per-node vmstats".  Without the patch, the
    CACHED line of "kmem -i" shows 0, and the VM_STAT section of "kmem -V" is
    missing entirely.

  * Fix for Linux 4.11 and later kernels that contain kernel commit
    4b3ef9daa4fc0bba742a79faecb17fdaaead083b, titled "mm/swap: split swap
    cache into 64MB trunks".  Without the patch, the CACHED line of "kmem -i"
    may show nonsensical data.

  * Implemented a new "dev -D" option that is the same as "dev -d", but
    filters out the display of disks that have no I/O in progress.

  * If a line number request for a module text address initially fails, force
    the embedded gdb module to complete its two-stage strategy used for
    reading debuginfo symbol tables from module object files, and then retry
    the line number extraction.  This automatically does what the "mod -r" or
    "crash --readnow" options accomplish.

  * Update for support of Linux 4.12 and later PPC64 kernels where the hash
    page table geometry accommodates a larger virtual address range.  Without
    the patch, the virtual-to-physical translation of user space virtual
    addresses by "vm -p", "vtop", and "rd -u" may generate an invalid
    translation or otherwise fail.

  * Implemented a new "runq -T" option that displays the time lag of each CPU
    relative to the most recent runqueue timestamp.

  * Fix to support Linux 4.15 and later kernels that contain kernel commit
    e8cfbc245e24887e3c30235f71e9e9405e0cfc39, titled "pid: remove pidhash".
    The kernel's traditional usage of a pid_hash[] array to store PIDs has
    been replaced by an IDR radix tree, requiring a new crash plug-in function
    to gather the system's task set.  Without the patch, the crash session
    fails during initialization with the error message "crash: cannot resolve
    init_task_union".

  * Fix for the "net" command when the network device listing has an unusually


=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
-Standards-Version: 3.9.8.0
+Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
+Standards-Version: 4.1.3.0
 XS-Testsuite: autopkgtest
 
 Package: crash

=== debian/rules ===
--- 
+++ 
@@ -8,14 +8,12 @@
 DPKG_EXPORT_BUILDFLAGS=1
 include /usr/share/dpkg/buildflags.mk
 
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-
 %:
 	dh $@ --with quilt
 
 override_dh_auto_build:
 	dh_auto_build 
-	$(MAKE) extensions
+	$(MAKE) extensions lzo snappy
 
 override_dh_auto_clean:
 	cp $(CURDIR)/Makefile $(CURDIR)/debian/Makefile.ori

=== debian/tests/control ===
Tests: live
Restrictions: needs-root isolation-machine
Depends: @, lsb-release, software-properties-common, sudo
